
/******************************************************************************/
/* Global Vars                                                                */
/******************************************************************************/

var gNumberRegEx = /(\+[0-9]{1,3})?[^+]?([0-9]+[^+]{0,2})+[0-9]+/ ;

var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].
	getService(Components.interfaces.nsIPrefBranch);

var hostname = gPrefs.getCharPref("extensions.asterisk.host");
var port = gPrefs.getCharPref("extensions.asterisk.port");

/******************************************************************************/
/* Init                                                                       */
/******************************************************************************/

try
{
//	var gManager = new AsteriskAJAM();
//	gManager.open(hostname, port);
	var gManager = new AsteriskManager();
	gManager.open(hostname, "5038");
}
catch(e)
{
}

if( window.getBrowser ) window.getBrowser().addEventListener("load", load, true);


/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

// add event listeners for click and for the page load.
function load(event)
{
	var parsedocument = gPrefs.getBoolPref("extensions.asterisk.parsedocument");
	if( !parsedocument )
	{
		// firefox
	   	if(document.getElementById("contentAreaContextMenu"))
	   	{
	   		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", onHideContext, true);
	   	}
	   	// thunderbird
		if(document.getElementById("messagePaneContext"))
		{
	   		document.getElementById("messagePaneContext").addEventListener("popupshowing", onHideContext, true);
	   	}
		return;
	}

//	var frame=null;
	// auto load for Firefox
/*	frame = window.document.getElementById("appcontent");
	if( frame )
	{
		frame.addEventListener("DOMContentLoaded",parseDOM,false);
		//frame.addEventListener("DOMFrameContentLoaded",parseDOM,false);
	}
*/
	// auto load for Thunderbird
/*	frame = document.getElementById("messagepane");
	if( frame )
	{
		frame.addEventListener("DOMContentLoaded",parseDOM,false);
		//frame.addEventListener("DOMFrameContentLoaded",parseDOM,false);
	}
*/
}

function onHideContext()
{
	var selection = getBrowserSelection();
	//alert("calling context with: "+selection);
	if( selection )
	{
		var number = cleanPhoneNumber(selection);
		if( number.length > 0 )
		{
			document.getElementById("context-asterisk").label = "Call: "+number;
			document.getElementById("context-asterisk-edit").label = "Edit&Call: "+number;
			document.getElementById("context-asterisk").hidden = false;
			document.getElementById("context-asterisk-edit").hidden = false;
		}
		else
		{
			document.getElementById("context-asterisk").hidden = true;
			document.getElementById("context-asterisk-edit").hidden = true;
		}
	}
	else
	{
		document.getElementById("context-asterisk").hidden = true;
		document.getElementById("context-asterisk-edit").hidden = true;
	}
}

function dial(phonenumber)
{  
	var host = gPrefs.getCharPref("extensions.asterisk.host");
    var port = gPrefs.getCharPref("extensions.asterisk.port");
    var username = gPrefs.getCharPref("extensions.asterisk.username");
    var password = gPrefs.getCharPref("extensions.asterisk.password");
    var context = gPrefs.getCharPref("extensions.asterisk.context");
//    var priority = gPrefs.getCharPref("extensions.asterisk.priority");
    var channel = gPrefs.getCharPref("extensions.asterisk.channel");
//    var callerid = gPrefs.getCharPref("extensions.asterisk.callerid");


//    var host = "pabx.acipia.local";
//    var port = "5038";
//    var username = "test";
//    var password = "testsecret";
//    var context = "internal";
    var priority = "1";
//    var channel = "SIP/211";
    var callerid = phonenumber;
//    var phonenumber = "213";

	var logoff = function() {
		gManager.logoff();
	};

	var originate = function() {
		gManager.originate(channel, phonenumber, context, logoff);
	};
	
	gManager.login(username, password, originate);
	
}


function ConfirmDial(number)
{
    if( confirm("Call: "+number+" ?") )
    {
    	dial(number);
    }
}

function EditConfirmDial(number)
{
    if( result = prompt("Call: ", number) )
    {
    	dial(result);
    }
}


function cleanPhoneNumber(phoneNum)
{
	//alert(phoneNum);
	//var number = phoneNum;
	var number_a = phoneNum.match(gNumberRegEx);
	if( !number_a ) return "";
	var number = number_a[0];
	//alert(number);

	number = number.replace(/[^0-9+]+/g,"");
	
	//alert(number);
	
	var len = number.length;
	
	if( number.substr(0,1) == "+" )
	{
		if( number.substr(1,2) == "33" )
		{
			number = "0" + number.substr(3, len-3);
		}
		else
		{	// problème si le code pays tiens sur 3 numéros
			number = "00" + number.substr(1,len-1);
		}
	}
	
    return number;
}


