

function AsteriskManager()
{
	this.transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"]
			.getService(Components.interfaces.nsISocketTransportService);

	this.transport = null;
	this.outstream = null;

	// default parameters
	this.hostname = "pabx";
	this.port = "5038";

	
	this.open = function (hostname, port)
	{
		this.hostname = hostname;
		this.port = port;
		try
		{
			this.transport = this.transportService.createTransport(null,0,this.hostname,this.port,null);
			this.outstream = this.transport.openOutputStream(0,0,0);
		}
		catch (e)
		{
			alert("cannot connect to server");
		}
	}

	this.login = function (username, password, onReady)
	{
		var outputData = "Action: Login\r\n"
		+ "Username: " + username  + "\r\n"
		+ "Secret: " + password  + "\r\n"
		+ "Events: off\r\n\r\n";
		this.action(outputData,onReady);
	}

	this.logoff = function (onReady)
	{
		var outputData = "Action: Logoff\r\n\r\n";
		this.action(outputData,onReady);
	}

	this.originate = function (channel, phonenumber, context, onReady)
	{
		var outputData = "Action: Originate\r\n"
		+ "Exten: " + phonenumber + "\r\n"
		+ "Context: " + context + "\r\n"
		+ "Priority: 1\r\n"
		+ "Channel: " + channel + "\r\n"
		+ "Callerid: " + phonenumber + "\r\n"
		+ "Timeout: 5000\r\n\r\n";
		this.action(outputData,onReady);
	}
	
	this.action = function(outputData, onReady)
	{
		this.outstream.write(outputData,outputData.length);
		onReady();
	}
}


